import sublime, sublimeplugin, os, os.path, re

# References and citations

class TexCiteCommand(sublimeplugin.TextCommand):
	def run(self, view, args):
		print "entering texCite"
		# test only for now
		# get current point
		# assume no selection, or a singe selection (for now)
		currsel = view.sel()[0]
		point = currsel.b
		prefix = view.substr(view.word(point)).strip()
		print currsel, point, prefix,len(prefix)
		completions = []
		# For now we only get completions from bibtex file
		bibcmd = view.substr(view.find(r'\\bibliography\{(.+)\}',0))
		print bibcmd
		bibp = re.compile(r'\{(.+)\}')
		bibmatch = bibp.search(bibcmd)
		if not bibmatch:
			print "Cannot parse bibliography command: " + bibcmd
			return
		bibfname = bibmatch.group(1)
		print bibfname
		if bibfname[-4:] != ".bib":
			bibfname = bibfname + ".bib"
		texfiledir = os.path.dirname(view.fileName())
		bibfname = os.path.normpath(texfiledir + os.path.sep + bibfname)
		print bibfname 
		bibf = open(bibfname)
		bib = bibf.readlines()
		bibf.close()
		kp = re.compile(r'@[^\{]+\{(.+),')
		tp = re.compile(r'\btitle\b[^\{]+\{(.+)\}', re.IGNORECASE)
		kp2 = re.compile(r'([^\t]+)\t*')
		keywords = [kp.search(line).group(1) for line in bib if line[0] == '@']
		titles = [tp.search(line).group(1) for line in bib if tp.search(line)]
		if len(keywords) != len(titles):
			print "Bibliography " + bibfname + " is broken!"
		completions = ["%s\t\t%s" % kt for kt in zip(keywords, titles)]
		if not prefix in ["", "{}"]:
			fcompletions = [comp for comp in completions if prefix in comp]
		else:
			prefix = "" # in case it's {}
			fcompletions = completions
#		view.showCompletions(point, prefix, fcompletions)
		
		def onSelect(i):
			key = kp2.search(fcompletions[i]).group(1)
			# if no selection, and current character is not space, 
			# extend to word
			# Note: we crash if currsel.a=0, but that means that we are trying
			# to enter a reference as the very first character of the file!
			if currsel.a == currsel.b and view.substr(currsel.a-1) != ' ': 
				newsel = view.word(point)
			else:
				newsel = currsel
			view.replace(newsel, "\\cite{" + key + "}")
			newsel = sublime.Region(newsel.a + 1, newsel.a+5)
			view.sel().clear()
			view.sel().add(newsel)
		
		view.window().showSelectPanel(fcompletions, onSelect, None, 0)
		print "done"